console.log('injected');
console.log('injected fiddler functions');
let serviceManage = [];
let serviceManagepage = [];

const rtpconst = {
    dbapiEndpoint: document.getElementById('dataVerseEndpoint').value,
    dsapiEndpoint: document.getElementById('datasourcesEndpoint').value,
    queryMethod: {
        get: "GET",
        post: "POST",
        patch: "PATCH",
        put: "PUT",
        delete: "DELETE"
    },
    recordState: {
        create: 1,
        update: 2,
        delete: 3
    },
    datasourceFuntions: {
        connect: 'authorize',
        disconnect: 'disconnect',
        verify: 'verify',
        refresh: 'refresh'
    }
}

function parseEntities(controlName, isFullControlLink) {
    let output;
    let elName = '#entities.hidden #' + controlName;
    if (isFullControlLink) {
        elName = controlName;
    }
    try {
        let data = $(elName).text();
        if (data) {
            output = JSON.parse(data);
        } else {

        }
    } catch (error) {
        console.log('error parse ' + controlName, error);
    }
    return output
}

async function initToken() {
    const tokenControl = $('#tokenAppid');
    if (!tokenControl.length) {
        return null;
    }
    const cid = tokenControl.attr('clientid');
    const response = await fetch("/_services/auth/token?client_id=" + cid, { method: rtpconst.queryMethod.post });
    const token = await response.text();
    localStorage.setItem('access', token);
    return token;
}

async function apicall(method, entityName, recordId, params) {
    let output = {
        status: false,
        data: null
    };
    let callUrl = rtpconst.dbapiEndpoint + entityName;
    const requestProperties = {
        method: method,
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        },
    };
    if (params) {
        requestProperties.body = JSON.stringify(params);
    };
    if (recordId) {
        callUrl += '/' + recordId;
    }
    try {
        const token = await initToken();
        if (!token) {
            throw new Error('Token Retrieve Exception!');
        }
        requestProperties.headers['Authorization'] = 'Bearer ' + token;
        const response = await fetch(callUrl, requestProperties);

        if (response.ok) {
            console.log('response', response);
            output.status = response.ok;
            output.data = await response.json();
            if (output.data.error) {
                output.status = false;
            }
        } else {
            throw new Error(response.statusText)
        }

    } catch (requestError) {
        console.log('API Call Exception', requestError);
    }
    return output;

}

async function DataSourcesApi(method, datasourceId, functionType) {
    let output = {
        status: false,
        data: null
    };
    let callUrl = rtpconst.dsapiEndpoint;
    const requestProperties = {
        method: method,
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        },
    };

    if (datasourceId) {
        callUrl += datasourceId;
    } else {
        return output;
    }

    switch (functionType) {
        case rtpconst.datasourceFuntions.connect:
            callUrl += '/' + rtpconst.datasourceFuntions.connect;
            break;

        case rtpconst.datasourceFuntions.disconnect:
            callUrl += '/' + rtpconst.datasourceFuntions.disconnect;
            break;

        case rtpconst.datasourceFuntions.verify:
            callUrl += '/' + rtpconst.datasourceFuntions.verify;
            break;
        case rtpconst.datasourceFuntions.refresh:
            callUrl += '/' + rtpconst.datasourceFuntions.refresh;
            break;
        default:
            break;
    }
    try {
        const token = await initToken();
        if (!token) {
            throw new Error('Token Retrieve Exception!');
        }
        requestProperties.headers['Authorization'] = 'Bearer ' + token;
        const response = await fetch(callUrl, requestProperties);

        if (response.ok) {
            console.log('response', response);
            output.status = response.ok;
            output.data = await response.text();
            if (output.data.error) {
                output.status = false;
            }
        } else {
            throw new Error(response.statusText)
        }

    } catch (requestError) {
        console.log('API Call Exception', requestError);
    }
    return output;
}

async function portalSafePostQuery(_inputQueryMethod, _inputUrl, _body) {
    try {
        let _callUrl = _inputUrl;
        if (_callUrl.indexOf(window.location.origin) == -1) {
            const flowGuid = _inputUrl.split('/_api/cloudflow/v1.0/trigger/');
            if (flowGuid[1]) {
                _callUrl = window.location.origin + '/_api/cloudflow/v1.0/trigger/' + flowGuid[1];
            }
        }

        if (!shell) {
            throw new Error('Not found postal Shell on page.');
        }

        let response = await shell.ajaxSafePost({
            url: _callUrl,
            type: _inputQueryMethod,
            contentType: 'application/json',
            data: JSON.stringify(_body),
            processData: false,
            global: false
        });
        if (response) {
            return JSON.parse(response);
        } else {
            return;
        }
    } catch (error) {
        console.log('portalSafePostQuery error', error);
        return;
    }
}

function internalDataQuery(_inputQueryMethod, _callUrl, _body) {
    return new Promise(function (resolve, reject) {
        if (!webapi) {
            sweetAlertTostMessage('', 'Unable to companies data request. Please try again later or contact suppor.', 'error');
            resolve(false);
        }
        const queryParams = {
            type: _inputQueryMethod,
            url: _callUrl,
            contentType: "application/json",
            success: function (result, status, xhr) {
                if (xhr.status >= 200 && xhr.status < 300) {
                    if (xhr.status == 204) {
                        result = true;
                    }
                    resolve(result);
                } else {
                    console.log('Error In Api');
                    resolve(false);
                }
            },
            error: (a, b, c) => {
                console.log('webapi.safeAjax failed', b, a, c);
                sweetAlertTostMessage('', 'Unable to complete action. Please try again later or contact suppor.', 'error');
                resolve(false);
            }
        }
        if (_body) {
            queryParams.data = JSON.stringify(_body);
        }
        webapi.safeAjax(queryParams);

    });
}

// Notifications 

let notifyTimer;
$(document).ready(() => {
    enableNavigationItems();
    setTimeout(() => {
        receiveNotifications();
    }, 0);
});

async function receiveNotifications() {
    const notyfyContent = $('#notifyContent').text() ? JSON.parse($('#notifyContent').text()) : [];
    apicall(rtpconst.queryMethod.get, 'ContactNotification', null, null).then((contactNotificationResponse) => {
        if (contactNotificationResponse.status) {
            const activeNofityItems = [];
            let notifyHTML = '';
            contactNotificationResponse.data.forEach(contactNotify => {
                if (contactNotify.StatusCode !== 860230001 && contactNotify.NotificationId) {
                    const notifyItem = notyfyContent.filter((n) => n.Id == contactNotify.NotificationId)[0];
                    if (notifyItem) {
                        let calltoAction = '';
                        if (notifyItem.CallToActionEndpoint) {
                            let pathPart = '/' + notifyItem.CallToActionEndpoint;
                            pathPart = pathPart.replace(/\/\//g, "/");
                            calltoAction = 'href="' + window.location.origin + pathPart + '"';
                        }
                        const urgency = '';// notifyItem.Urgency ? `<s>${notifyItem.Urgency} - </s> ` : '';
                        const body = notifyItem.Body ? `<b class="text-xs text-gray-400">${notifyItem.Body}</b>` : '';
                        notifyHTML += `<div id="notify_${contactNotify.Id}" class="flex w-full hover:shadow">
                        <a class="block w-full px-8 py-5" ${calltoAction}>${urgency}${notifyItem.Name}${body}
                        </a>
                        <svg x-data x-tooltip="Mark as read" onclick="markNotifyAsRead($(this),'${contactNotify.Id}')" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" class="h-10 p-3 my-4 w-14 stroke-[#008D76] hover:shadow">
                            <path d="M9 12.75L11.25 15 15 9.75M21 12a9 9 0 11-18 0 9 9 0 0118 0z" />
                        </svg>                  
                    </div>`;
                        activeNofityItems.push(contactNotify);
                    }
                }
            });
            if (notifyHTML) {
                $('#notifyItemsList').html(notifyHTML);
                $('#notifyCountContainer').removeClass('invisible');
                $('#notifyCount').html(activeNofityItems.length);

            } else {
                $('#notifyCountContainer').addClass('invisible');
                $('#notifyCount').html('');
                $('#notifyCount').html('');
            }
        }
        if (notifyTimer) {
            clearTimeout(notifyTimer);
            notifyTimer = null;
        }
        notifyTimer = setTimeout(() => {
            receiveNotifications();
        }, 300000);
    });
}

function enableNavigationItems() {
    $.each($('#navbar a:not([link-type])'), function (navIndex, navItem) {
        let isMenuItemAvailable = false;
        if ($(navItem).attr('modules')) {
            const linkModules = $(navItem).attr('modules').split(';');
            const modulesFound = [];
            linkModules.forEach(function (keyName) {
                serviceManage.filter(function (manageItem) {
                    if (manageItem.ModuleKey == keyName) {
                        modulesFound.push(manageItem);
                    }
                });
            });
            isMenuItemAvailable = modulesFound.length > 0;
        }
        if (!isMenuItemAvailable) {
            $(navItem).addClass('!hidden');
        }
    });
    $.each($('.menudivider[modules]'), function (dividerIndex, dividerItem) {
        let isDividerVisible = false;
        if ($(dividerItem).attr('modules')) {
            $(dividerItem).attr('modules').split(';').filter(function (keyname) {
                isDividerVisible = serviceManage.filter(function (moduleItem) {
                    if (moduleItem.ModuleKey == keyname) {
                        return moduleItem;
                    }
                }).length > 0;
            });
        }
        if (!isDividerVisible) {
            $(dividerItem).addClass('!hidden');
        }
    });
}

function getServiceManage(isPage) {
    let postfix = isPage ? 'page' : '';
    try {
        const _serviceManage = JSON.parse($('#servicemanage' + postfix).text());
        if (_serviceManage) {
            if (!postfix) {
                serviceManage = _serviceManage;
            } else {
                serviceManagepage = _serviceManage;
            }
        }
    } catch (error) {
        console.error('getServiceManage:', error);
    }
}

getServiceManage();

function isModuleDisplay(moduleName) {
    const result = serviceManagepage.filter(function (el) {
        if (el.ModuleKey == moduleName) {
            return el;
        }
    });
    return result.length > 0;
};

function getPermissionsFoPage(_pageId) {
    let output;
    if (!_pageId || !serviceManage) {
        return;
    }
    output = serviceManage.filter(function (el) {
        if (el.PageId == _pageId) {
            return el;
        }
    });
    return output;
}

async function markNotifyAsRead(event, notifyId) {
    debugger;
    if($(event)){
        $(event).addClass('!hidden')
    }
    $(`#notify_${notifyId}`).remove();
    const requestParams = {
        Id: notifyId,
        Status: 860230001
    };
    const markReadResponse = await apicall(rtpconst.queryMethod.patch, 'ContactNotification', notifyId, requestParams);
    if (markReadResponse.status) {
        console.log('markReadResponse', markReadResponse.data);
    }
    receiveNotifications();
}

function sweetAlertConfirmMessage(inputTitle, inputText, icon, confirmText, disableCancel) {
    return new Promise((resolve, reject) => {
        const toastOptions = {
            icon: icon,
            title: inputTitle,
            text: inputText,
            showConfirmButton: true,


            customClass: {
                confirmButton: '!flex-1 !p-2 !text-white !bg-[#008D76] !border !rounded !font-light focus:!shadow-none',
                denyButton: '!bg-[#008D76]/10 !border !p-2 !rounded !text-black !font-light focus:!shadow-none'
            }
        }
        if (confirmText) {
            toastOptions.confirmButtonText = confirmText;
        } else {
            toastOptions.confirmButtonText = 'Ok';
        }
        if (!disableCancel) {
            toastOptions.showDenyButton = true;
            toastOptions.denyButtonText = 'Cancel';
        }
        Swal.fire(toastOptions).then((result) => {
            if (result.isConfirmed) {
                resolve(true);
            } else if (result.isDenied) {
                resolve(false)
            }
        });
    });

}

function sweetAlertTostMessage(CustomTargetId, text, iconText) {
    const toastOptions = {
        position: 'top-end',
        title: text,
        showConfirmButton: false,
        timerProgressBar: true,
        timer: 10000,
        toast: true,
        customClass: {
            title: 'text-[12px]',
            popup: 'text-[12px]',
            confirmButton: '!bg-[#008D76] !border !p-2 !rounded !text-black',
            cancelButton: '!bg-[#008D76]/10'
        }
    }
    if (iconText) {
        toastOptions.icon = iconText;
    }

    if (CustomTargetId) {
        toastOptions.target = '#' + CustomTargetId;
    }
    Swal.fire(toastOptions)
}

function sweetAlertTost(CustomTargetId) {
    const toastOptions = {
        position: 'top-end',
        icon: 'success',
        title: 'Your Downloading started\nPlease review \'Downloads folder\' or browser download section.',
        showConfirmButton: true,
        timerProgressBar: true,
        toast: true,
        customClass: {
            title: 'text-[12px]',
            popup: 'text-[12px]',
            confirmButton: '!bg-[#008D76]/10 !border !p-2 !rounded !text-black',
        }
    }
    if (CustomTargetId) {
        toastOptions.target = '#' + CustomTargetId;
    }
    Swal.fire(toastOptions)
}

function getLocalization() {
    let output = {};
    try {
        output = translation;
    } catch (error) {
        console.log('getLocalization Error', error);
    }
    return output;
}

let onboardingwidget;
let helpcenterapp;
let achivementsApp;

$(document).ready(() => {
    const { createApp } = Vue;
    if ($('#onboardingWidget').length) {
        onboardingwidget = createApp({
            data() {
                return {
                    strings: {},
                    ContactId: '',
                    AccountId: '',
                    AccountName: '',
                    isLoading: false,
                    Visible: false,
                    onboarding: null,
                    exists: false,
                    started: false,
                    completedItems: 0,
                    completedPercents: 0,
                    onboardingFlowUrl: '',
                    onboardingPageUrl: '/Onboarding',
                    onbQType: {
                        retrieve: 'retrieve',
                        movenext: 'movenext'
                    }
                }
            },
            methods: {
                async getOnboarding(onboardingQueryType, currentId, nextId) {
                    const data = {};
                    data.AccountId = this.AccountId;
                    data.ContactId = this.ContactId;
                    data.RequestType = onboardingQueryType;
                    data.NextId = '';
                    data.CurrentId = '';
                    this.safeFlowRequest(data).then(this.processingResponse);
                },
                async safeFlowRequest(requestData) {
                    let out;
                    const flowuri = this.onboardingFlowUrl;
                    try {
                        if (flowuri) {
                            this.isLoading = true;
                            const payload = {}
                            payload.eventData = JSON.stringify(requestData);
                            const response = await portalSafePostQuery(rtpconst.queryMethod.post, flowuri, payload);
                            if (response) {
                                const r = await JSON.parse(response);
                                if (r.status) {
                                    this.isLoading = false;
                                    out = r;
                                } else {
                                    throw new Error('Error In Flow');
                                }
                            } else {
                                throw new Error('Error with response')
                            }
                        }
                    } catch (error) {
                        console.log('getOnboarding error', error);
                        sweetAlertTostMessage('', 'Unable to complete onboarding action. Please try again later or contact support.', 'error');
                        this.isLoading = false;
                    }
                    return out;
                },
                completeStep(currentStep, currentIndex) {
                    const nextIndex = currentIndex + 1;
                    let nextId = '';
                    if (this.onboarding.OnboardingItems[nextIndex]) {
                        const nextStep = this.onboarding.OnboardingItems[nextIndex];
                        nextId = nextStep.Id
                    } else if (nextIndex == this.onboarding.OnboardingItems.length) {
                        nextId = 'last';
                    }
                    const data = {};
                    data.AccountId = this.AccountId;
                    data.ContactId = this.ContactId;
                    data.RequestType = this.onbQType.movenext;
                    data.NextId = nextId;
                    data.CurrentId = currentStep.Id;
                    this.safeFlowRequest(data).then(this.processingResponse);
                },
                composeOnboardingItems(_onboarding) {
                    _onboarding.OnboardingItems = _onboarding.OnboardingItems.map((item) => {
                        if (item.Description.length > 40) {
                            let shortDesc = item.Description.substring(0, 37);
                            shortDesc = shortDesc[shortDesc.length - 1] && shortDesc[shortDesc.length - 1] == ' ' ? shortDesc[shortDesc.length - 1] = '' : shortDesc;
                            item.ShorDescription = shortDesc + '...';
                        }
                        return item;
                    });
                    return _onboarding;
                },
                completedPercentage(_inputItems) {
                    let out = 0;
                    if (!_inputItems && !_inputItems.length) {
                        return out
                    }
                    this.completedItems = _inputItems.filter((el) => { if (el.IsCompleted) { return el } }).length;
                    out = (this.completedItems / _inputItems.length) * 100;
                    return out;
                },
                checkIfNeedToShow(_onboarding) {
                    const completedItems = _onboarding.OnboardingItems.filter((el) => { if (el.IsCompleted) { return el; } });
                    return completedItems.length !== _onboarding.OnboardingItems.length;
                },
                processingResponse(onbResult) {
                    if (onbResult) {
                        if (this.checkIfNeedToShow(onbResult)) {
                            const _onboarding = this.composeOnboardingItems(onbResult);
                            this.onboarding = _onboarding;
                            this.Visible = true;
                        } else {
                            this.Visible = false;
                        }
                    }
                },
                outsideTrigger() {
                    this.getOnboarding(this.onbQType.retrieve);
                }
            },
            watch: {
                onboarding(newValue, oldValue) {
                    if (newValue) {
                        this.completedPercentage(newValue.OnboardingItems);
                    }
                }
            },

            async beforeMount() {
                this.strings = getLocalization();
                this.ContactId = $('#contactid').val();
                this.AccountId = $('#accountid').val();
                this.AccountName = $('#accountid').attr('accountname');
                this.onboardingFlowUrl = $('#onboardingFlowUrl').val();
                const onboardingcompleted = $('#onboardingcompleted').val() === 'true';
                const onboardingexists = $('#onboardingexists').val() === 'true';
                const onboardingstarted = $('#onboardingstarted').val() === 'true';
                if (!onboardingcompleted && onboardingexists && onboardingstarted) {
                    this.getOnboarding(this.onbQType.retrieve);
                }
            }
        }).mount('#onboardingWidget');
    }

    if ($('#helcenterapp').length) {
        helpcenterapp = createApp({
            data() {
                return {
                    ContactId: '',
                    AccountId: '',
                    Enabled: true,
                    AlreadyVisited: false,
                    Displayed: false,
                    bounceEnabled: true,
                    searchtext: 'my search text',
                    toggleOpacity: true,
                    helpFlowUrl: null,
                    wfEndpoint: null,
                    dialogId: 'helpVideoDialog',
                    questions: [
                    ]
                }
            },
            methods: {
                async validateHelpVisited() {
                    const flowuri = this.helpFlowUrl;
                    const _contactId = $('#contactid').val();
                    const _pageId = $('#RootPageId').val();
                    try {
                        if (flowuri && _pageId && _contactId) {
                            const data = {};
                            data.ContactId = _contactId;
                            data.PageId = _pageId;
                            const payload = {}
                            payload.eventData = JSON.stringify(data);
                            const helpValidation = await portalSafePostQuery(rtpconst.queryMethod.post, flowuri, payload);
                            if (helpValidation) {
                                console.log("helpValidation", helpValidation);
                                if (helpValidation.status) {
                                    if (helpValidation && helpValidation.show) {
                                        this.onToggleHelp();
                                    }
                                } else {
                                    throw new Error('Error In Flow');
                                }
                            } else {
                                throw new Error('Error with response')
                            }

                        }
                    } catch (error) {
                        console.log('validateHelpVisited error', error);
                        sweetAlertTostMessage('', 'Unable to complete help center data action. Please try again later or contact support.', 'error');
                    }
                },
                onToggleHelp() {
                    const newState = !this.Displayed;
                    if (!this.Displayed && this.bounceEnabled) {
                        this.bounceEnabled = false;
                    }
                    if (!newState) {
                        this.toggleOpacity = true;
                        setTimeout(() => {
                            this.questions.forEach((el) => {
                                el.expanded = false;
                            });
                            this.Displayed = newState
                        }, 500);
                    } else {
                        this.Displayed = newState
                        setTimeout(() => {
                            this.toggleOpacity = false;
                        }, 50);
                    }
                },
                expandQuestion(_item) {
                    _item.expanded = !_item.expanded;
                    this.questions.forEach(element => {
                        if (element.id !== _item.id) {
                            element.expanded = false;
                        }
                    });
                },
                openContent(_relateditem) {
                    if (_relateditem.type != 'video') {
                        window.open(_relateditem.link, '_blank');
                    } else {
                        this.downloadFile(_relateditem);
                    }
                },
                async downloadFile(_contentItement) {
                    if (_contentItement.IsDownloading) {
                        return;
                    }

                    if (_contentItement && _contentItement.id) {
                        await this.retrieveVideo(_contentItement);
                    }
                },
                async retrieveVideo(_downloadFileItem) {
                    const _modalContentId = 'helpModalContent';
                    const _modalTitleId = 'helpModalTitle';

                    try {
                        const flowUrl = this.wfEndpoint;
                        const token = await initToken();
                        if (!token) {
                            throw new Error('Token Retrieve Exception!');
                        }
                        const requestBody = {
                            ContactId: this.ContactId,
                            AccountId: this.AccountId,
                            token: token,
                        }

                        if (_downloadFileItem) {
                            requestBody.FileUniqueId = _downloadFileItem.id;
                        }
                        const requestProperties = {
                            method: rtpconst.queryMethod.post,
                            headers: {
                                'Accept': 'application/json',
                                'Content-Type': 'application/json',
                                'Authorization': 'Bearer ' + token
                            },
                            body: JSON.stringify(requestBody)
                        }
                        _downloadFileItem.IsRetriving = true;
                        const contentLibRespose = await fetch(flowUrl, requestProperties);
                        if (contentLibRespose.status >= 200 && contentLibRespose.status < 300) {
                            const responseData = await contentLibRespose.json();
                            if (responseData.status) {
                                if (!responseData.isBlobUri) {
                                    const contentUrl = `data:${responseData.data['$content-type']};base64,${responseData.data['$content']}`;
                                    var link = document.createElement("a");
                                    link.setAttribute('id', 'downloadSampleLink')
                                    link.setAttribute("href", contentUrl);
                                    link.setAttribute("download", _downloadFileItem.filename);
                                    link.style = "visibility:hidden";
                                    document.body.appendChild(link);
                                    link.click();
                                    setTimeout(function () { document.body.removeChild(link); }, 500);
                                    _downloadFileItem.IsRetriving = false;
                                    sweetAlertTost();
                                } else {
                                    console.log('BLOB DATA', responseData.data);
                                    if (_downloadFileItem.type == 'video') {
                                        $('#' + _modalContentId).html('');
                                        let titleText = '';
                                        let htmlModalContent = '';
                                        switch (_downloadFileItem.type) {
                                            case 'video': {
                                                htmlModalContent = '<video width="640" height="480" controls controlsList="nodownload"> <source src="' + responseData.data + '"></video>' +
                                                    '<div  class="flex justify-end mt-2 w-full" > <button id="mediaDownloadControl" class="relative p-2 border rounded bg-blue-50" onclick="downloadMediaSample(\'' + responseData.data + '\', \'' + _downloadFileItem.filename + '\',false)"  >Download</button></div>';
                                                titleText = 'Watch Now'
                                                break;
                                            }
                                            case 'audio': {
                                                htmlModalContent = '<audio width="640" height="480" class="w-full" controls controlsList="nodownload"><source src="' + responseData.data + '" ></audio>' +
                                                    '<div  class="flex justify-end mt-2 w-full" > <button id="mediaDownloadControl"  class="relative p-2 border rounded bg-blue-50" onclick="downloadMediaSample(\'' + responseData.data + '\', \'' + _downloadFileItem.filename + '\', true)"  >Download</button></div>';
                                                titleText = 'Listen Now'
                                                break;
                                            }
                                        }
                                        composeDialogContent(_modalTitleId, titleText, _modalContentId, htmlModalContent);
                                        openDialog(this.dialogId);
                                        _downloadFileItem.IsRetriving = false;
                                    } else {
                                        _downloadFileItem.IsRetriving = false;
                                        const savingAvaited = await saveOrOpenBlob(responseData.data, _downloadFileItem);
                                        if (savingAvaited) {
                                            console.log('savingAvaited', savingAvaited);
                                            sweetAlertTost();
                                        }
                                    }
                                }

                            } else {
                                throw new Error('Error Retrieve Content');
                            }
                        } else {
                            throw new Error(contentLibRespose.statusText)
                        }
                    } catch (error) {
                        console.log('Error retrieveContent', error);
                        _downloadFileItem.IsRetriving = false;
                        sweetAlertTostMessage('', "Sorry, unable to download files. If you keep having this problem contact us.", "warning")
                    }
                },
                closeVideoDialog() {
                    closeDialog(this.dialogId);
                    $('#helpVideoDialogContent').html('');
                },
                composeEntities(_items) {
                    return _items.map((item) => {
                        item.description = item.description.replace(/\\n/g, '&#13;&#10;');
                        if (item.VideoInfo) {
                            const videoData = item.VideoInfo.split(';#');
                            const _videoFileName = videoData[1];
                            item.relatedContent.push({
                                filename: videoData[1],
                                id: videoData[0],
                                info: videoData[2],
                                link: "#",
                                name: _videoFileName.split('.')[0],
                                type: "video"
                            })
                        }
                        item.relatedContent.forEach((el, index) => {
                            if (el.info && !isNaN(parseInt(el.info))) {
                                el.info = formatBytes(parseInt(el.info))
                            }
                            el.IsRetriving = false;
                            el.IsDownloading = false;
                            el.DownloadPercentage = '0%';
                        });
                        return item;
                    });
                }
            },
            async beforeMount() {
                this.strings = getLocalization();
                this.ContactId = $('#contactid').val();
                this.AccountId = $('#accountid').val();
                this.AccountName = $('#accountid').attr('accountname');
                this.helpFlowUrl = $('#helpPageVisitedFlowUrl').val();
                this.wfEndpoint = $('#retrieveWFEnpoint').val();
                this.AlreadyVisited = $('#helpCenterVisitState').val() === "1" ? true : false;
                const _questions = parseEntities('#helpentities #questionsItems', true);
                if (_questions) {
                    this.questions = this.composeEntities(_questions);
                }
            },
            mounted() {
                if (!this.AlreadyVisited) {
                    this.validateHelpVisited();
                }
                setTimeout(() => {
                    this.bounceEnabled = false;
                }, 20000);
            }
        }).mount('#helcenterapp');
    }

    if ($('#companyachivementsapp')) {
        achivementsApp = createApp({
            data() {
                return {
                    achivementsToggleTimeout: undefined,
                    showed: false,
                    activeTabIndex: 0,
                    CompaniesAmount: 0,
                    RTPGroupsAmount: 0,
                    topItems: [],
                    tabs: [
                        {
                            id: 1,
                            name: "My Achievements",
                            selected: true,
                            items: [
                                // { id: 'test1', name: 'test achive one', description: 'dsdsd', subInfo: 'sub info 1' },
                                // { id: 'test2', name: 'test achive two', subInfo: 'sub info 2' }
                            ]
                        },
                        {
                            id: 2,
                            name: "Locked Achievements",
                            selected: false,
                            items: []
                        },
                        {
                            id: 3,
                            name: "Group Achievements",
                            selected: false,
                            items: []
                        }
                    ]
                }
            },
            methods: {
                enableAchiveWidget(isOut) {
                    if (this.achivementsToggleTimeout) {
                        clearTimeout(this.achivementsToggleTimeout);
                        this.achivementsToggleTimeout = undefined;
                    }
                    if (isOut) {
                        const $this = this;
                        this.achivementsToggleTimeout = setTimeout(function () {
                            $this.showed = false;
                        }, 500);
                    } else {
                        this.showed = true;
                    }
                },
                selectTab(_tab, _tabIndex) {
                    this.activeTabIndex = _tabIndex;
                    this.tabs.map((el, ind) => {
                        el.selected = _tab.id == el.id && ind == _tabIndex;
                        return el;
                    });
                },
                calculateOwningAmount(_allAchievemnt, _achivementId, _inputObjectId, calculateForGroup) {
                    let totalAmount = this.CompaniesAmount;
                    let outputAmount = '0';
                    let ownPropName = 'accountid';
                    if (calculateForGroup) {
                        ownPropName = 'groupid';
                        totalAmount = this.RTPGroupsAmount;
                    }

                    const ownedAmount = _allAchievemnt.filter((ownRecord) => {
                        if (ownRecord[ownPropName] != _inputObjectId && ownRecord.achievementid == _achivementId) {
                            return ownRecord;
                        }
                    }).length;
                    if (!ownedAmount || !totalAmount) {
                        return '';
                    }
                    if (totalAmount) {
                        outputAmount = (ownedAmount / totalAmount * 100).toFixed(0);
                    }
                    return `${outputAmount}% of community has this`;
                },
                composeAchivements(_inputItems, _inputAchievements, isGroup) {
                    let checkObjectId = this.AccountId;
                    let ownPropName = 'accountid';
                    if (isGroup) {
                        ownPropName = 'groupid';
                        checkObjectId = this.RTPGroupId;
                    }
                    let output = _inputItems.map((el) => {
                        el.achievement = _inputAchievements.filter((achive) => {
                            if (achive.achiveid == el.achievementid) {
                                achive.subInfo = this.calculateOwningAmount(_inputItems, achive.achiveid, checkObjectId, isGroup);
                                return achive;
                            }
                        })[0];
                        if (el.achievement) {
                            return el;
                        }
                    });
                    return output;
                },
                filterItems(_tabIndex) {
                    let output = this.tabs[_tabIndex].items;

                    if (_tabIndex == 1) {
                        return output;
                    }
                    let propName = 'accountid';
                    let compareValue = this.AccountId;
                    if (_tabIndex == 2) {
                        propName = 'groupid';
                        compareValue = this.RTPGroupId;
                    }
                    output = output.filter((el) => {
                        if (el[propName] == compareValue) {
                            return el;
                        }
                    });
                    return output;
                },
                composeLockedAchievements(_allAchievemnts, _companyAchives, _groupAchives) {
                    return _allAchievemnts.filter((achiveItem) => {
                        let amountInCompany = _companyAchives.filter((el) => {
                            if (el.accountid == this.AccountId && el.achievement) {
                                return el;
                            }
                        }).filter((el) => {
                            if (el.achievementid == achiveItem.achiveid) {
                                return el;
                            }
                        }).length;

                        let amountInGroup = _groupAchives.filter((el) => {
                            if (el.groupid == this.RTPGroupId && el.achievement) {
                                return el;
                            }
                        }).filter((el) => {
                            if (el.achievementid == achiveItem.achiveid) {
                                return el;
                            }
                        }).length;
                        if (amountInCompany == 0 && amountInGroup == 0) {
                            return achiveItem;
                        }
                    }).map((el) => {
                        return {
                            achievement: el,
                            locked: true
                        };
                    });
                },
                getTopAchivements() {
                    let _company = this.tabs[0].items.filter((el) => { if (el.accountid == this.AccountId) { return el } });
                    let _group = this.tabs[2].items.filter((el) => { if (el.groupid == this.RTPGroupId) { return el } });
                    return _company.concat(_group).slice(0, 1);
                }
            },
            async beforeMount() {
                this.strings = getLocalization();
                this.ContactId = $('#contactid').val();
                this.AccountId = $('#accountid').val();
                this.RTPGroupId = $('#contactrtpgroupid').val();
                this.AccountName = $('#accountid').attr('accountname');
                this.CompaniesAmount = $('#amountofCompanies').val() ? parseInt($('#amountofCompanies').val()) : 0;
                this.RTPGroupsAmount = $('#amountofRTPGroups').val() ? parseInt($('#amountofRTPGroups').val()) : 0;
                const _achievements = parseEntities('#achivementsentities #achievements', true);
                const _compnayAchivements = parseEntities('#achivementsentities #allcompaniesAchivements', true);
                const _groupAchievements = parseEntities('#achivementsentities #allGroupsAchievements', true);
                if (_achievements && _compnayAchivements && _groupAchievements) {
                    let companyAchivements = this.composeAchivements(_compnayAchivements, _achievements);
                    let groupachievenments = this.composeAchivements(_groupAchievements, _achievements, true);
                    let notUnlocked = this.composeLockedAchievements(_achievements, companyAchivements, groupachievenments);
                    this.tabs[0].items = companyAchivements;
                    this.tabs[1].items = notUnlocked;
                    this.tabs[2].items = groupachievenments;
                    this.topItems = this.getTopAchivements();
                }
            },
            mounted() {
                $('#companyachivementsapp').removeClass('hidden');
            }
        }).mount('#companyachivementsapp');
    }
});

function formatBytes(bytes, decimals = 2) {
    if (!+bytes) return '0 Bytes'

    const k = 1024
    const dm = decimals < 0 ? 0 : decimals
    const sizes = ['b', 'Kb', 'Mb', 'Gb', 'Tb', 'Pb', 'Eb', 'Zb', 'Yb']

    const i = Math.floor(Math.log(bytes) / Math.log(k))

    return `${parseFloat((bytes / Math.pow(k, i)).toFixed(dm))} ${sizes[i]}`
}

function openDialog(dialogId) {
    const dialog = document.getElementById(dialogId);
    dialog.showModal();
    document.body.classList.add('overflow-hidden');
    dialog.addEventListener('click', (event) => {
        const rect = dialog.getBoundingClientRect();
        if (rect.top > event.clientY || rect.bottom < event.clientY || rect.left > event.clientX || rect.right < event.clientX) {
            dialog.close();
            document.body.classList.remove('overflow-hidden');
        }
    });
}

function closeDialog(dialogId) {
    const dialog = document.getElementById(dialogId);
    dialog.close();
    document.body.classList.remove('overflow-hidden');
}

function composeDialogContent(_titleId, _titleText, _bodyId, _bodyHtml) {
    $('#' + _titleId).text(_titleText);
    $('#' + _bodyId).prepend(_bodyHtml)
}

function downloadMediaSample(Url, name, isAudio) {
    if (isAudio) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', Url, true);
        xhr.responseType = 'blob';
        xhr.onload = function () {
            var urlCreator = window.URL || window.webkitURL;
            var contentUrl = urlCreator.createObjectURL(this.response);
            var tag = document.createElement('a');
            tag.href = contentUrl;
            tag.target = '_blank';
            tag.download = name;
            document.body.appendChild(tag);
            tag.click();
            document.body.removeChild(tag);
        };
        xhr.onerror = err => {
            console.log('Failed to download picture');
        };
        xhr.send();
    } else {
        var tag = document.createElement('a');
        tag.href = Url;
        tag.target = '_blank';
        tag.download = name;
        document.body.appendChild(tag);
        tag.click();
        document.body.removeChild(tag);
    }
    sweetAlertTost()
}

function saveOrOpenBlob(url, _downloadFileItem) {
    _downloadFileItem.IsDownloading = true;
    return new Promise((resolve, reject) => {
        const newurl = url;
        fetch(newurl)
            .then(response => {
                const contentLength = response.headers.get('content-length');
                // Gets length in bytes (must be provided by server)
                let loaded = 0;
                // Will be used to track loading
                return new Response(
                    new ReadableStream({
                        // Creates new readable stream on the new response object
                        start(controller) {
                            // Controller has methods on that allow the new stream to be constructed
                            const reader = response.body.getReader();
                            // Creates a new reader to read the body of the fetched resources
                            read();
                            // Fires function below that starts reading
                            function read() {
                                reader.read()
                                    .then((progressEvent) => {
                                        // Starts reading, when there is progress this function will fire
                                        if (progressEvent.done) {
                                            controller.close();
                                            return;
                                            // Will finish constructing new stream if reading fetched of resource is complete
                                        }
                                        loaded += progressEvent.value.byteLength;
                                        // Increase value of 'loaded' by latest reading of fetched resource
                                        // console.log(Math.round(loaded / contentLength * 100) + '%');
                                        _downloadFileItem.DownloadPercentage = Math.round(loaded / contentLength * 100) + '%'
                                        // Prints progress to output div as percentage
                                        controller.enqueue(progressEvent.value);
                                        // Add newly read data to the new readable stream
                                        read();
                                        // Runs function again to continue reading and creating new stream
                                    })
                            }
                        }
                    })
                );
            })
            .then(response => response.blob()) // Read new readable stream to blob
            .then(blob => {
                var fileName = _downloadFileItem.Name;
                var tempEl = document.createElement("a");
                document.body.appendChild(tempEl);
                tempEl.style = "display: none";
                url = window.URL.createObjectURL(blob);
                tempEl.href = url;
                tempEl.download = fileName;
                tempEl.click();
                window.URL.revokeObjectURL(url);
                resolve(true);
                _downloadFileItem.IsDownloading = false;
                _downloadFileItem.DownloadPercentage = '0%';
            }).catch((error) => {
                _downloadFileItem.IsDownloading = false;
                _downloadFileItem.DownloadPercentage = '0%';
                console.log('saveOrOpenBlob Error', error)
                reject('During Downloading file!');
            })
    });
}

// active company management 
// let companies = [];
// async function retrieveCompanies(_contactId) {
//     if (_contactId) {
//         const queryParams = [
//             `$filter=statecode eq 0 and _tbg_contact_value eq '${_contactId}'`,
//             `$orderby=_tbg_account_value asc`
//         ]
//         const items = await internalDataQuery(rtpconst.queryMethod.get, `/_api/tbg_contact_rtpgroups?${queryParams.join('&')}`);
//         console.log('companies items', items);
//         if (items && items.value) {
//             // companies = items.value;
//             let html = '';
//             items.value.forEach(company => {
//                 let companyContent = `<b class="px-4 py-2 bg-white">
//                 ${company._tbg_account_value ? company["_tbg_account_value@OData.Community.Display.V1.FormattedValue"] : '— // —'}
//             </b>
//             <b class="px-4 py-2 bg-white">
//                 ${company.tbg_groupclassname ? company.tbg_groupclassname : '— // —'}
//             </b>`;
//                 if (company.tbg_isactiveforuser) {
//                     companyContent += `<b class="flex gap-2 px-4 py-2 bg-white ">
//                     Active <svg viewBox="0 0 24 24" class="w-5 h-5 stroke-[#008D76]">
//                         <path d="M9 12.75L11.25 15 15 9.75M21 12a9 9 0 11-18 0 9 9 0 0118 0z" />
//                     </svg>
//                 </b>`
//                 } else {
//                     let isButtonDisabled = true
//                     if (company.tbg_groupclassname && company._tbg_account_value) {
//                         isButtonDisabled = false;
//                     }
//                     companyContent += `<button type="button" ${!isButtonDisabled ? ` onclick="setCompanyToActive('${company.tbg_contact_rtpgroupid}')"` : ' disabled="true"'}
// class="w-full px-4 py-2 truncate transition rounded -blue-200 whitespace-nowrap bg-[#008D76]/10 hover:shadow">Activate</button>`
//                 }
//                 html += companyContent;
//             });
//             $('#companies').html(html);
//         }
//     }
// }

async function toggleCompany(_companyId, _state) {
    // const _url = `/_api/tbg_contact_rtpgroups(${_companyId})/tbg_isactiveforuser`;
    // const _params = {
    //     value: _state
    // }
    // const response = await internalDataQuery(rtpconst.queryMethod.put, _url, _params);
    // console.log('update company internalDataQuery response', response);
    // return response;
    const _url = `/_api/tbg_contact_rtpgroups(${_companyId})`;
    const _params = {
        tbg_isactiveforuser: _state
    }
    const response = await internalDataQuery(rtpconst.queryMethod.patch, _url, _params);
    console.log('update company internalDataQuery response', response);
    return response;
}

async function setCompanyToActive(_newCompanyId) {
    if (_newCompanyId) {
        // let _currentCompany = companies.filter(function (el) {
        //     if (el.tbg_isactiveforuser) {
        //         return el;
        //     }
        // })[0];
        if ($('#currentActiveCompanyId').val())
            // if (_newCompanyId && _currentCompany && _currentCompany.tbg_contact_rtpgroupid) {
            if (_newCompanyId && $('#currentActiveCompanyId').val()) {
                toggleLoader(true);
                const resultCurrent = await toggleCompany($('#currentActiveCompanyId').val(), false);
                const resultNew = await toggleCompany(_newCompanyId, true);
                if (resultCurrent && resultNew) {
                    console.log('resultCurrent', resultCurrent, 'resultNew', resultNew);
                    window.location.reload();
                    toggleLoader(false);
                } else {
                    toggleLoader(false);
                }
                // toggleLoader(true);
                // const responses = await Promise.all([toggleCompany($('#currentActiveCompanyId').val(), false), toggleCompany(_newCompanyId, true)])
                // if (responses && responses.filter(function (el) { if (el == false) { return el; } }).length == 0) {
                //     console.log('responses', responses);
                //     window.location.reload();
                // } else {
                //     toggleLoader(false);
                // }
            }
    }
}